﻿CashMod = {};

addModEventListener(CashMod);

function CashMod:registerActionEvent()
    if g_currentMission.player ~= nil then
        if not g_currentMission:getHasPlayerPermission("transferMoney") then
            return
        end
        if g_currentMission.player.farmId == FarmManager.SPECTATOR_FARM_ID then
            return
        end
    end
    InputBinding.registerActionEvent(g_inputBinding, "CashMod_ADD1MILLION" , self, CashMod.handleAction, false ,true ,false ,true)
    InputBinding.registerActionEvent(g_inputBinding, "CashMod_TAKE1MILLION" , self, CashMod.handleAction, false ,true ,false ,true)
    InputBinding.registerActionEvent(g_inputBinding, "CashMod_ADDTHOUSAND" , self, CashMod.handleAction, false ,true ,false ,true)
    InputBinding.registerActionEvent(g_inputBinding, "CashMod_TAKETHOUSAND" , self, CashMod.handleAction, false ,true ,false ,true)
end

function CashMod.handleAction(self, actionName, keyStatus, arg4, arg5, arg6) 
    if not g_currentMission:getHasPlayerPermission("transferMoney") then
        return
    end
    if g_currentMission.player.farmId == FarmManager.SPECTATOR_FARM_ID then
        return
    end
    local switch = {
        ["CashMod_ADD1MILLION"] = function()
            g_currentMission:addMoney(1000000, g_currentMission.player.farmId, "addMoney");
        end,
        ["CashMod_TAKE1MILLION"] = function()
            g_currentMission:addMoney(-1000000, g_currentMission.player.farmId, "addMoney");
        end,
        ["CashMod_ADDTHOUSAND"] = function()
            g_currentMission:addMoney(100000, g_currentMission.player.farmId, "addMoney");
        end,
        ["CashMod_TAKETHOUSAND"] = function()
            g_currentMission:addMoney(-100000, g_currentMission.player.farmId, "addMoney");
        end
    }
    local action = switch[actionName]
    if action then
        action()
    end
end

BaseMission.registerActionEvents = Utils.appendedFunction(BaseMission.registerActionEvents, CashMod.registerActionEvent)
print("CashMod has now loaded...")